/*
 * @(#)InternalVariableKeeper.java
 */
import java.util.Hashtable;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

import jp.ac.kobe_u.cs.cream.*;
/**
 * @since 0.1
 * @version 0.9 Mar 6 2005
 * @author Naoyuki Tamura
 * @author Hideaki Okamoto
 */
public class InternalVariableKeeper {
    private Hashtable<String, Variable> variables_;
    private int next_id_;
    
    public InternalVariableKeeper() {
	this.variables_ = new Hashtable<String, Variable>();
	this.next_id_ = 0;
    }

    public Variable getVariable(String key) {
	Variable v = null;
	if (key != null)
	    v = (Variable)variables_.get(key);
	return v;
    }

    public String getVariableKey() {
	String key = "INTERNAL" + Integer.toString(next_id_);
	next_id_++;
	return key;
    }

    public void setVariable(String key, Variable v) {
	variables_.put(key, v);
    }

    public static boolean isInternalVariableKey(String key) {
	Pattern pattern = Pattern.compile("INTERNAL[\\d]*");
	Matcher matcher = pattern.matcher(key);
	return matcher.matches();
    }
}
